<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\EscoposTarefaService;

class EscoposTarefaController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $EscoposTarefaService;
   
    public function __construct($crudService, $environment, EscoposTarefaService $EscoposTarefaService) {
        parent::__construct($crudService, $environment);
        $this->EscoposTarefaService = $EscoposTarefaService;
    }
    
    public function escopo(DTO\Request $request, DTO\Response $response) {
        $method = $request->getMethod();
        if ($method == "GET") {
           $response->addDataSet(new DataSet('escopos', $this->EscoposTarefaService->getEscopo()));
        } else if ($method== "POST") {
           $response->addDataSet(new DataSet('escopos', $this->EscoposTarefaService->setEscopo($request->getParameters())));
        }
    }
    
    public function escoposComAtividadeChk(DTO\Request $request, DTO\Response $response) {
       $response->addDataSet(new DataSet('escopos', $this->EscoposTarefaService->escoposComAtividadeChk()));
    }
}

?>