<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\NewCode;
use FM\Service\FindService;
use FM\Traits\TResponse;

class FindController extends FMCrud
{
    use TResponse;
    protected $FindService;
   
    public function __construct($crudService, $environment, FindService $FindService) {
        parent::__construct($crudService, $environment);
        $this->FindService = $FindService;
    }

    public function findOperador(Request $request, Response $response){
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findOperador($filtro);
            $this->sendResponse($data, 200);
          } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
         }
    }

    public function findOperadorHierarq(Request $request, Response $response){
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findOperadorHierarq($filtro);
            $this->sendResponse($data, 200);
          } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
         }
    }

    public function findLocal(Request $request, Response $response){
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findLocal($filtro);
            $this->sendResponse($data, 200);
          } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
         }
    }

    public function findTipoLocal(Request $request, Response $response){
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findTipoLocal($filtro);
            $this->sendResponse($data, 200);
          } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
         }
    }

    public function findChecklist(Request $request, Response $response){
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findChecklist($filtro);
            $this->sendResponse($data, 200);
          } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
         }
    }

    public function findEscoposServicos(Request $request, Response $response){
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findEscoposServicos($filtro);
            $this->sendResponse($data, 200);
          } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
         }
    }

    public function findAtividades(Request $request, Response $response) {
        try {
                $filtro = $this->getFiltro($request);
                $data = $this->FindService->findAtividades($filtro);
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function findItensChecklist(Request $request, Response $response) {
        try {
                $filtro = $this->getFiltro($request);
                $data = $this->FindService->findItensChecklist($filtro);
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    private function getFiltro($request) {
        if(isset($request->getParameters()["find"])){
            $filtro = $request->getParameters()["find"];
        } else {
            $filtro = '';
        }
        return $filtro;
    } 

}
?>