<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\HierarquiaUsuariosService;
use FM\Traits\TResponse;

class HierarquiaUsuariosController extends FMCrud {

    use TResponse;

    protected $HierarquiaUsuariosService;

    public function __construct($crudService, $environment, HierarquiaUsuariosService $HierarquiaUsuariosService) {
            parent::__construct($crudService, $environment);
            $this->HierarquiaUsuariosService = $HierarquiaUsuariosService;
    }

    public function getHierarquia(Request $request, Response $response) {
        try {
            $data = $this->HierarquiaUsuariosService->getHierarquia();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
             $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }   
    }

    public function getHierarquiaDetalhes(Request $request, Response $response) {
        try {
                $data = $this->HierarquiaUsuariosService->getHierarquiaDetalhes($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getHierarquiaFacilities(Request $request, Response $response) {
        try {
                $data = $this->HierarquiaUsuariosService->getHierarquiaFacilities($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getHierarquiaUsuarios(Request $request, Response $response) {
        try {
                $data = $this->HierarquiaUsuariosService->getHierarquiaUsuarios($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getHierarquiaPais(Request $request, Response $response) {
        try {
                $data = $this->HierarquiaUsuariosService->getHierarquiaPais($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function inserirUsuarios(Request $request, Response $response) {
        try {
                $data = $this->HierarquiaUsuariosService->inserirUsuarios($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function salvarHierarquia(Request $request, Response $response){
        try {
            $params = $request->getParameters();
            $data = $this->HierarquiaUsuariosService->salvarHierarquia($params);
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirHierarquia(Request $request, Response $response){
        try {
            $params = $request->getParameters();
            $data = $this->HierarquiaUsuariosService->excluirHierarquia($params);
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirUsuarios(Request $request, Response $response){
        try {
            $params = $request->getParameters();
            $data = $this->HierarquiaUsuariosService->excluirUsuarios($params);
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
       

        public function getHierarquiaFunc(Request $request, Response $response) {
        
            try {
                $data = $this->HierarquiaUsuariosService->getHierarquiaFunc();
               
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                 $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
                }   
        }

         //Busca uma lista personalizada de usuários que podem ser adicionados na hierarquia
        public function getHierarchyUsers(Request $request, Response $response) {
        
            try {
                $data = $this->HierarquiaUsuariosService->getHierarchyUsers();
               
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                 $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
                }   
        }

}
?>