<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class FindFactory  {

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function findOperador($filtro) {

        $sql = "SELECT CDOPERADOR, NMOPERADOR
         FROM OPERADOR
        WHERE IDATIVO = 'S' 
          AND IDOPERATIVO = 'A'
          AND ".$filtro."
        ORDER BY NMOPERADOR";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);         

    }

    public function findOperadorHierarq($filtro) {

        $sql = "SELECT CDOPERADOR, NMOPERADOR
        FROM OPERADOR
        WHERE IDATIVO = 'S' 
          AND IDOPERATIVO = 'A'
          AND CDOPERADOR IN (SELECT  A.CDOPERADOR
                                         FROM FCM_FUNCIONARIOSHIERARQ A
                                         JOIN FCM_HIERARQUIAFUNC H 
                                           ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                                        WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                                      FROM FCM_HIERARQUIAFUNC
                                                                     WHERE IDATIVO = 'S')) 
        AND ".$filtro."
        ORDER BY NMOPERADOR";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);         

    }

    public function findLocal($filtro) {

        $sql = "SELECT NRLOCALCLIENTE, NMLOCALCLIENTE
                FROM FCM_LOCALCLI
                WHERE".$filtro."
                AND IDATIVO = 'S'
                ORDER BY NMLOCALCLIENTE";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findTipoLocal($filtro) {

        $sql = "SELECT NRTIPOLOCALCLI, NMTIPOLOCALCLI
                FROM FCM_TIPOLOCALCLI
                WHERE".$filtro."
                AND IDATIVO = 'S'
                ORDER BY NMTIPOLOCALCLI";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findChecklist($filtro) {
        $sql = "SELECT NRCHECKLIST, NMCHECKLIST
                FROM FCM_CHECKLIST
                WHERE".$filtro."
                AND IDATIVO = 'S'
                ORDER BY NMCHECKLIST";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findEscoposServicos($filtro) {

        $sql = "SELECT * FROM FCM_ESCOPOSTAREFA
                    WHERE".$filtro."
                    AND IDATIVO = 'S'
                    ORDER BY NMESCOPOSTAREFA";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }


    public function findAtividades($filtro) {

        $sql = "SELECT * FROM FCM_TAREFA
                WHERE".$filtro."
                AND IDATIVO = 'S'
                ORDER BY NMTAREFA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);        
    }

    public function findItensChecklist($filtro) {

        $sql = "SELECT * FROM FCM_ATIVIDADE
                WHERE".$filtro."
                AND IDATIVO = 'S'
                ORDER BY NMATIVIDADE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);        

    }
}
