/* eslint-disable */
import {
  Http, IDictionary, Metadata,
} from '@zeedhi/core';
import {
  AlertService, DialogService, Image, FileInput, LoadingService,
} from '@zeedhi/common';
import FileUpload from '../FileUpload';


export class TabLogotypeController {
  public showImage({ component }: any) {
    const componentImage = Metadata.getInstance<Image>('image-logotype');

    if (component.value) { // tamanho do fileInput
      componentImage.src = window.URL.createObjectURL(component.value);
      componentImage.isVisible = true;
    } else {
      componentImage.isVisible = false;
    }
  }

  public async sendImage(name: string) {
    const fileInputObject = [Metadata.getInstance<FileInput>(name).value];
    let arquivo: any = [];
    if (fileInputObject && fileInputObject.length > 0) {
      const types: IDictionary = ['image/jpg', 'image/jpeg', 'image/png'];
      const buildFilesPromises = fileInputObject.map((file: any) => {
        if (types.includes(file.type)) {
          return FileUpload.buildFileSendObject(file);
        }
      });
      await Promise.all(buildFilesPromises).then((files: any) => {
          arquivo  = files;
      });
    }
    return arquivo;
  }

  public async saveImage() {
    const img = await this.sendImage('FileInputl-imagens');
    Http.post('/sendImage', {
        NRPARCNEGOCIO: window.location.search.split('?')[1],
        DSDIRLOGOMARCA: img,
    }).then((response: IDictionary) => {
      const returnMessage = response.data.dataset.image[0];
      if (returnMessage === 'OK') {
        this.alertMessages('Logotipo salvo com sucesso!', 'success');
      } else {
        this.dialogMessage('Operação bloqueada! Este Logotipo não pôde ser salvo.<br><br>Se o problema persistir entre em contato com o suporte.');
      }
    });
  }

  public mountImages({ component }: any) {
    component.isVisible = true;
    Http.post('/getImage', {
        NRPARCNEGOCIO: window.location.search.split('?')[1],
    }).then((response: IDictionary) => {
      component.src = response.data.dataset.image[0].DSDIRLOGOMARCA;
    });
  }

  public alertMessages(message: string, type: string) {
    AlertService.show({
      name: 'basic-alert',
      text: message,
      top: true,
      left: false,
      timeout: 3000,
      color: type,
    });
  }

  public dialogMessage(message: string) {
    DialogService.show({
      name: 'warning-dialog',
      type: 'warning',
      title: 'Erro!',
      text: message,
    });
  }
}
