/* eslint-disable */
import { Utilities } from '@/util/Utilities';
import {
    CheckboxMultiple,
    DateRange,
    DialogService,
    Form,
    LoadingService,
    Modal, ModalService, Select, SelectMultiple, Switch, TextInput, Time,
} from '@zeedhi/common';
import { Http, IEventParam, Loader, Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class Fm00004000TarefasController {
    private basicModal!: Modal;

    private basicModalCriterio!: Modal;

    public hierarquiasController = Loader.getInstance('HierarquiasController');

    public visivel = true;

    public acessorVisivel = true;

    // ============Controle do modal==========
    public async exibirModalCadastroTarefas({ event }: any) {
        event.preventDefault();
        this.basicModal = await ModalService.createFromJson('fm_00004_000_tarefas/modal/fm_00004_001_modal_cadastro_tarefas', true);
        this.basicModal.show();
    }

    public async fecharModalTarefas() {
        this.basicModal.hide();
        this.basicModal?.destroy();
    }

    public async exibirModalCriterios() {
        this.basicModalCriterio = await ModalService.createFromJson('fm_00004_000_tarefas/modal/fm_00004_002_modal_cadastro_criterio', true);
        this.basicModalCriterio.show();
    }

    public async fecharModalCriterio() {
        this.basicModalCriterio.hide();
        this.basicModalCriterio?.destroy();
    }

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(`formTarefas_${component.name}`);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    // ==========Controles dos Selects ===================
    public changeTipoDeLocal() {
        const cliente = Metadata.getInstance<Select>('CDCLIENTE');
        const tipoLocal = Metadata.getInstance<Select>('NRTIPOLOCALCLI');
        if (cliente.value) {
            tipoLocal.disabled = false;
        } else {
            tipoLocal.disabled = true;
        }
    }

    public changeLocal() {
        const tipoLocal = Metadata.getInstance<Select>('NRTIPOLOCALCLI');
        const local = Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE');
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        if (tipoLocal.value.length > 0) {
            local.disabled = false;
            checklist.disabled = false;
            local.datasource.setFilter({
                NRLOCALCLIENTE: tipoLocal.value,
            });
            checklist.datasource.setFilter({
                NRLOCALCLIENTE: tipoLocal.value,
            });
        } else {
            local.setValue([]);
            local.disabled = true;
            checklist.setValue(null);
            checklist.disabled = true;
        }
    }

    public changeItensChecklist() {
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        const itenschecklist = Metadata.getInstance<SelectMultiple>('NRATIVIDADECHK');
        if (checklist.value) {
            itenschecklist.disabled = false;
            itenschecklist.datasource.setFilter({
                NRCHECKLIST: checklist.value,
            });
        } else {
            itenschecklist.setValue([]);
            itenschecklist.disabled = true;
        }
    }

    public changeEscopo() {
        const itenschecklist = Metadata.getInstance<SelectMultiple>('NRTIPOLOCALCLI');
        const escopo = Metadata.getInstance<Select>('NRESCOPOSTAREFA');
        if (itenschecklist.value.length > 0) {
            escopo.disabled = false;
        } else {
            escopo.setValue([]);
            escopo.disabled = true;
        }
    }

    public changeTarefa() {
        const escopo = Metadata.getInstance<SelectMultiple>('NRESCOPOSTAREFA');
        const tarefa = Metadata.getInstance<SelectMultiple>('NRTAREFACHK');
        const itenschecklist = Metadata.getInstance<Select>('NRATIVIDADECHK');
        if (escopo.value.length > 0) {
            tarefa.disabled = false;
            tarefa.datasource.setFilter({
                NRATIVIDADECHK: itenschecklist.value,
            });
        } else {
            tarefa.setValue([]);
            tarefa.disabled = true;
        }
    }

    public setCriterios() {
        const tarefa = Metadata.getInstance<SelectMultiple>('NRTAREFACHK');
        const itenschecklist = Metadata.getInstance<Select>('NRATIVIDADECHK');
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        const checkbox = Metadata.getInstance<CheckboxMultiple>('NRCRITERIOTAREFACHK');
        if (tarefa.value.length > 0) {
            checkbox.datasource?.setFilter({
                NRTAREFACHK: tarefa.value,
                NRATIVIDADECHK: itenschecklist.value,
                NRCHECKLIST: checklist.value,
            });
            checkbox.datasource?.get();
            checkbox.isVisible = true;
        } else {
            tarefa.setValue([]);
            checkbox.isVisible = false;
        }
    }

    public novoCriterio() {
        const chk = Metadata.getInstance<CheckboxMultiple>('NRCRITERIOTAREFACHK');
        const valor = Metadata.getInstance<TextInput>('inputNovoCriterio').value;
        chk!.datasource!.data!.push({
            NRCRITERIOTAREFACHK: valor,
            DSCRITERIOTAREFA: valor,
        });
        chk!.value.push(valor);
        this.fecharModalCriterio();
    }

    public validaVistoria() {
        const vistoria = Metadata.getInstance<Select>('selectCriarVistoria');
        const observacao = Metadata.getInstance<Select>('selectObservacoesObrigatorias');
        if (vistoria.value == 1) {
            observacao!.datasource!.data!.push({
                value: '3',
                text: "Somente na vistoria",
            });
            observacao!.datasource!.data!.push({
                value: '4',
                text: "Na tarefa e na vistoria",
            });
        } else {
            observacao.datasource?.get();

        }
    }

    public validaDiaPeriodo(data: any, data2: any, dias: any) {
        for (let dataAux = data; data <= data2; dataAux.setDate(dataAux.getDate() + 1)) {
            if (dias.includes(String(dataAux.getDay()))) {
                return true;
            }
        }
        return false;
    }

    public inserirTarefa({ component }: IEventParam<TekGrid>) {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas');
        const checkBoxMultiple = Metadata.getInstance<CheckboxMultiple>('NRCRITERIOTAREFACHK');
        const formTarefas = Metadata.getInstance<Form>('formCadastroTarefas').validate();
        const formCriterios = Metadata.getInstance<Form>('formTarefas_dropBoxCriterioAvaliacao').validate();
        const formAgendamento = Metadata.getInstance<Form>('formTarefas_dropBoxDadosAgendamento').validate();
        const form = Metadata.getInstance<Form>('formTarefas_dropBoxDadosAgendamento');
        const switchValues = Metadata.getInstance<Switch>('switchFunionario');
        if (formTarefas && formCriterios && formAgendamento) {
            const diaSemana = Metadata.getInstance<SelectMultiple>('selectDiaSemana').value;
            const dataRange = Metadata.getInstance<DateRange>('selectDataDe').value;
            if (this.validaDiaPeriodo(new Date(dataRange[0]), new Date(dataRange[1]), diaSemana)) {
                let dados = [];
                for (let pos = 4; pos < (form.children.length - 1); pos += 1) {
                    let codigoPos: any = form.children[pos];
                    codigoPos = codigoPos.children[1].name.substr(16);
                    dados.push({
                        HORAINICIO: Metadata.getInstance<Time>('selectHoraInicio' + String(codigoPos)).value,
                        DURACAO: Metadata.getInstance<TextInput>('selectdDuracao' + String(codigoPos)).value,
                        FUNCIONARIO: Metadata.getInstance<Select>('selectFuncionario' + String(switchValues.value ? 1 : codigoPos)).value,
                        ENCARREGADO: Metadata.getInstance<Select>('selectEncarregado' + String(switchValues.value ? 1 : codigoPos)).value,
                    });
                }
                LoadingService.show();
                Http.post('/insertNovaTarefa', {
                    NOMETAREFA: Metadata.getInstance<TextInput>('nomeTarefa').value,
                    CDCLIENTE: Metadata.getInstance<Select>('CDCLIENTE').value,
                    NRTIPOLOCALCLI: Metadata.getInstance<SelectMultiple>('NRTIPOLOCALCLI').value,
                    NRLOCALCLIENTE: Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE').value,
                    NRCHECKLIST: Metadata.getInstance<Select>('NRCHECKLIST').value,
                    NRATIVIDADECHK: Metadata.getInstance<SelectMultiple>('NRATIVIDADECHK').value,
                    NRESCOPOSTAREFA: Metadata.getInstance<SelectMultiple>('NRESCOPOSTAREFA').value,
                    NRTAREFACHK: Metadata.getInstance<SelectMultiple>('NRTAREFACHK').value,
                    NRCRITERIOTAREFACHK: checkBoxMultiple.datasource?.data.filter((box: any) => checkBoxMultiple.value.indexOf(box.NRCRITERIOTAREFACHK) >= 0),
                    DATERANGE: dataRange,
                    DIASEMANA: diaSemana,
                    VISTORIA: Metadata.getInstance<Select>('selectCriarVistoria').value,
                    OBSERVACOES: Metadata.getInstance<Select>('selectObservacoesObrigatorias').value,
                    EXECUTORHORA: dados,
                    SWITCHFUNCIONARIO: Metadata.getInstance<Select>('switchFunionario').value
                }).then(() => {
                    Utilities.showSuccessMessage();
                    this.fecharModalTarefas();
                    grid.datasource.get();
                }).catch((error: any) => {
                    Utilities.showErrorMessage(error);
                }).finally(() => {
                    LoadingService.hide();
                });
            } else {
                DialogService.show({
                    name: 'error_dialog',
                    type: 'error',
                    title: 'Erro',
                    text: "O período selecionado não possui o(s) dia(s) da semana escolhido.",
                });
            }
        }
    }

    public excluirTarefas({ event }: any) {
        Utilities.showConfirmDeleteMessage(event, 'Fm00004000TarefasController.aposConfirmarDelete', 'Excluir Registro?');
    }

    public aposConfirmarDelete() {
        const component = Metadata.getInstance<TekGrid>('tek-grid-tarefas');
        LoadingService.show();
        Http.post('/deletarTarefas', {
            NRS: component.selectedRows.map((element: any) => element.NRCHECKLISTAGEND),
        }).then(() => {
            component.datasource.get();
            Utilities.showSuccessMessage();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            component.selectedRows = [];
            LoadingService.hide();
            DialogService.hide();
        });
    }

    //Controle do campo de adicionar e deletar novas linhas 
    public async novoHorario() {
        const form = Metadata.getInstance<Form>('formTarefas_dropBoxDadosAgendamento');
        const switchValue = Metadata.getInstance<Switch>('switchFunionario');
        let numAleatorio: any;

        // while responsável por atribuir aletaróriamente um número no fim dos "names" para nao gerar conflito.
        while (true) {
            numAleatorio = Math.floor(Math.random() * 100);
            if (form.children.filter((element: any) => element.name == "selectHoraInicio" + String(numAleatorio))) {
                break;
            }
        }

        if (form.children.length > 6) {
            const formulario: any = form?.children[form.children.length - 2];
            formulario.children[0].style.visibility = "hidden";
        }
        const renderizar = this.criaNovoHorario(numAleatorio);
        form.children = form.children.slice(0, form.children.length - 1).concat(renderizar, form.children[form.children.length - 1]);

        if (switchValue.value) {
            this.acessorVisivel = false;
        } else {
            this.acessorVisivel = true;
        }
        switchValue.disabled = true;
    }

    public removeHorario() {
        const form = Metadata.getInstance<Form>('formTarefas_dropBoxDadosAgendamento');
        const switchValue = Metadata.getInstance<Switch>('switchFunionario');
        form.children.splice(form.children.length - 2, 1);

        if (form.children.length > 6) {
            const formulario: any = form?.children[form.children.length - 2];
            formulario.children[0].style.visibility = "visible";
        } else {
            switchValue.disabled = false;
        }
    }

    // Molde para inserção de novos componentes ao modal de cadastro
    public criaNovoHorario(n: number): any {
        return [
            {
                name: "linhaColuna" + String(n),
                component: "ZdRow",
                justify: "space-between",
                grid: {
                    cols: 12
                },
                children: [
                    {
                        name: "botaoLixeira" + String(n),
                        component: "ZdButton",
                        icon: true,
                        small: true,
                        iconName: "mdi-trash-can-outline",
                        disabled: false,
                        cssClass: "zd-mt-4",
                        events: {
                            click: "{{Fm00004000TarefasController.removeHorario}}"
                        },
                        style: {
                            margin: "0 3% 1% 3%"
                        }
                    },
                    {
                        name: "selectHoraInicio" + String(n),
                        component: "ZdTime",
                        autocomplete: false,
                        label: "Horário Inicial",
                        timeFormat: "24hr",
                        placeholder: "00:00",
                        cssClass: "zd-mt-2",
                        mask: "##:##",
                        validations: {
                            required: {}
                        },
                        style: {
                            width: "17%"
                        }
                    },
                    {
                        name: "colSelectdDuracao" + String(n),
                        component: "ZdCol",
                        cols: 3,
                        children: [
                            {
                                name: "selectdDuracao" + String(n),
                                component: "ZdTextInput",
                                label: "Duração (minutos)",
                                placeholder: "00:00",
                                mask: "##:M#",
                                validations: {
                                    required: {},
                                    minLength: {
                                        limit: 4
                                    }
                                }
                            }
                        ]
                    },
                    {
                        name: "colSelectFuncionario" + String(n),
                        component: "ZdCol",
                        cols: 3,
                        children: [
                            {
                                name: "selectFuncionario" + String(n),
                                component: "ZdSelect",
                                autocomplete: false,
                                label: "Operador",
                                dataText: "NMOPERADOR",
                                dataValue: "CDOPERADOR",
                                isVisible: "{{Fm00004000TarefasController.acessorVisivel}}",
                                datasource: {
                                    route: "/getFuncionario",
                                    lazyLoad: true,
                                    type: "rest",
                                    loadAll: true
                                }
                            }
                        ]
                    },
                    {
                        name: "colSelectEncarregado" + String(n),
                        component: "ZdCol",
                        cols: 3,
                        children: [
                            {
                                name: "selectEncarregado" + String(n),
                                component: "ZdSelect",
                                autocomplete: false,
                                label: "Encarregado",
                                dataText: "NMOPERADOR",
                                columns: "3",
                                isVisible: "{{Fm00004000TarefasController.acessorVisivel}}",
                                dataValue: "CDOPERADOR",
                                datasource: {
                                    route: "/getSupervisorTarefa",
                                    lazyLoad: true,
                                    type: "rest",
                                    loadAll: true
                                }
                            }
                        ]
                    }
                ]
            }
        ];
    }

}